<template>
<div>
    <h4 class="text-center">{{room.name}}</h4>
        <v-divider/>
        <div v-if="room.temperature.installed" class="field">
        <v-icon :color="color" v-on:click="decrementTemperature" @click="$emit('update-room',room)">mdi-minus</v-icon>
        <v-progress-circular
        :rotate="90"
        :size="100"
        :width="15"
        :value="room.temperature.value*3.3333"
        :color="color"
        class="my-3"
        v-on:change="$emit('update-room',room)">
        {{room.temperature.value}}°C
        </v-progress-circular>
        <v-icon :color="color" v-on:click="incrementTemperature" @click="$emit('update-room',room)">mdi-plus</v-icon>
        <v-divider/>
        </div> 
        <div v-if="room.lights.installed" class="field">
        <span>The current light intensity is <b>{{room.lights.value}}</b>.</span>
        <v-slider
          v-model="room.lights.value"
          :color="color"
          track-color="grey"
          always-dirty
          min="0"
          max="20"
          class="my-3"
          v-on:change="$emit('update-room',room)">
          <template v-slot:prepend>
              <v-icon :color="color" v-on:click="decrementLights" @click="$emit('update-room',room)">mdi-minus</v-icon>
          </template>
          <template v-slot:append>
            <v-icon :color="color" v-on:click="incrementLights" @click="$emit('update-room',room)">mdi-plus</v-icon>
          </template>
        </v-slider>
        <v-divider/>
        </div>
        <div v-if="room.curtains.installed">
            <v-row align="center">
            <v-col>Curtains are <b>currently {{room.curtains.value?'Closed':'Open'}}</b>. <br>Click on the box to {{room.curtains.value?'Open':'Close'}} them:</v-col>
            <v-col><v-checkbox v-model="room.curtains.value" v-on:change="$emit('update-room',room)"></v-checkbox></v-col>
            </v-row>
        <v-divider/>
        </div>
        <div v-if="room.volume.installed" class="field">
            <v-icon class="my-3" large :color="color" v-if="room.volume.installed">{{room.volume.value>0?'mdi-volume-high':'mdi-volume-variant-off'}}</v-icon>
            <br>
            <v-icon :color="color" v-on:click="decrementVolume" @click="$emit('update-room',room)">mdi-minus</v-icon>
            <span>{{room.volume.value}}</span>
            <v-icon :color="color" v-on:click="incrementVolume" @click="$emit('update-room',room)">mdi-plus</v-icon>
            <p class="subtitle-2"> Current volume in this room</p>
            <v-divider/>
        </div>
    <v-btn :color="color" @click="$emit('room-click',room)" class="my-3">Make changes to room</v-btn>
    </div>
</template>

<script>
export default {
    name: "Room",
    props: {
        room: {
            type: Object,
            required:true
        },
        color: {
            type: String,
            default:"blue"
        }
    },
    methods:{
        incrementLights(){
            (this.room.lights.value==20? null: this.room.lights.value++)
        },
        decrementLights(){
            (this.room.lights.value==0? null: this.room.lights.value--)
        },
        incrementTemperature(){
            (this.room.temperature.value==30? null: this.room.temperature.value++)
        },
        decrementTemperature(){
            (this.room.temperature.value==0? null: this.room.temperature.value--)
        },
        incrementVolume(){
            (this.room.volume.value==20? null: this.room.volume.value++)
        },
        decrementVolume(){
            (this.room.volume.value==0? null: this.room.volume.value--)
        }
    }
};
</script>